package com.shxy.i2.Tool;

import cn.hutool.core.util.StrUtil;
import com.shxy.i2.bean.AttrBean;
import com.shxy.i2.bean.YxAttrBean;
import com.shxy.i2.constant.Constant;

import java.util.ArrayList;

public class GenerateI2Xml {

    public static String generateCacXml(String type, String sensorid, String equipmentid, String timestamp, ArrayList<AttrBean> attrlist) {
        String cacdata = "";
        cacdata += "<datanode sensorid=\"" + sensorid + "\"> ";
        cacdata += "<type>" + type + "</type> ";
        cacdata += "<equipmentid>" + equipmentid + "</equipmentid> ";
        if (StrUtil.isNotEmpty(timestamp)) {
            cacdata += "<timestamp>" + timestamp + "</timestamp> ";
        }
        cacdata += "<attrs> ";
        for (AttrBean bean : attrlist) {
            cacdata += "<attr name=\"" + bean.getKey() + "\" value=\"" + bean.getValue() + "\" alarm=\"FALSE\" /> ";
        }
        cacdata += "</attrs> ";
        cacdata += "</datanode>";
        return cacdata;
    }

    public static String generateEndCacXml(ArrayList<String> cacdatalist) {
        String cacxml = "";
        cacxml += "<?xml version=\"1.0\" encoding=\"UTF-8\"?> ";
        cacxml += "<request> ";
        cacxml += "<monitordata cacid=\"" + Constant.Cacid + "\" datanodenum=\"" + cacdatalist.size() + "\"> ";
        for (String str : cacdatalist) {
            cacxml += str;
        }
//        cacxml += "</attrs> ";
//        cacxml += "</datanode>";
        cacxml += "</monitordata> ";
        cacxml += "</request> ";

        return cacxml;
    }

    public static String generateYxCacXml(YxAttrBean<Integer> attr) {
        String cacdata = "";
        String sensorid = attr.getSensorid();
        String equipmentid = attr.getEquipmentid();
        String devicetype = attr.getDevicetype();
        String timestamp = attr.getTimestamp();
        String key = attr.getKey();
        Integer value = attr.getValue();
        String phase = attr.getPhase();

        String status = "FALSE";
        if (value != null) {
            if (value.intValue() == 0) {
                status = "FALSE";
            } else {
                status = "TRUE";
            }
            if (StrUtil.isNotEmpty(sensorid) && StrUtil.isNotEmpty(equipmentid) && StrUtil.isNotEmpty(timestamp) && StrUtil.isNotEmpty(key)) {
                cacdata += "<?xml version=\"1.0\" encoding=\"UTF-8\"?> ";
                cacdata += "<request> ";
                cacdata += "<monitordata cacid=\"" + Constant.Cacid + "\" datanodenum=\"" + 1 + "\"> ";
                cacdata += "<datanode sensorid=\"" + sensorid + "\"> ";
                cacdata += "<type>" + devicetype + "</type> ";
                cacdata += "<equipmentid>" + equipmentid + "</equipmentid> ";
                if (StrUtil.isNotEmpty(timestamp)) {
                    cacdata += "<timestamp>" + timestamp + "</timestamp> ";
                }
                cacdata += "<attrs> ";
                cacdata += "<attr name=\"Phase\" value=\"" + phase + "\" alarm=\"" + status + "\" /> ";
                cacdata += "<attr name=\"" + key + "\" value=\"" + value + "\" alarm=\"" + status + "\" /> ";
                cacdata += "</attrs> ";
                cacdata += "</datanode>";
                cacdata += "</monitordata> ";
                cacdata += "</request> ";
            }
        }
        return cacdata;
    }
}
