package com.shxy.i2.serviceimpl;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.date.DatePattern;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.NumberUtil;
import cn.hutool.core.util.StrUtil;
import com.shxy.i2.Tool.AsyncMethod;
import com.shxy.i2.Tool.GenerateI2Xml;
import com.shxy.i2.bean.AttrBean;
import com.shxy.i2.bean.SendDataBean;
import com.shxy.i2.bean.YxAttrBean;
import com.shxy.i2.constant.Constant;
import com.shxy.i2.dao.*;
import com.shxy.i2.dto.Data_YxlDto;
import com.shxy.i2.entity.*;
import com.shxy.i2.service.XydlI2Service;
import lombok.extern.slf4j.Slf4j;
import org.apache.cxf.endpoint.Client;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

@Service
@Slf4j
public class XydlI2ServiceImpl implements XydlI2Service {

    @Autowired
    private Data_SF6_QtylDao data_sf6_qtylDao;

    @Autowired
    private Data_Byq_JbfdDao data_byq_jbfdDao;

    @Autowired
    private Data_CnjDao data_cnjDao;

    @Autowired
    private Data_DcywDao data_dcywDao;

    @Autowired
    private Data_Dlq_JbfdDao data_dlq_jbfdDao;

    @Autowired
    private Data_Dr_JyjcDao data_dr_jyjcDao;

    @Autowired
    private Data_FhdlbxDao data_fhdlbxDao;

    @Autowired
    private Data_FhzxqDao data_fhzxqDao;

    @Autowired
    private Data_Jsyhw_JyjcDao data_jsyhw_jyjcDao;

    @Autowired
    private Data_SF6_QtsfDao data_sf6_qtsfDao;

    @Autowired
    private Data_TxDao data_txDao;

    @Autowired
    private Data_WsDao data_wsDao;

    @Autowired
    private Data_YspDao data_yspDao;

    @Autowired
    private Data_MicroclimateDao data_microclimateDao;


    @Autowired
    private Upload_checkDao upload_checkDao;

    @Autowired
    private Data_YxDao data_yxDao;

    @Autowired
    AsyncMethod asyncMethod;

//    @Value("${webservice.sendlimit}")
//    public int sendlimit;

    public static int sendlimit = 500;

    @Override
    public void upload_byq_jbfd(Client client, HashMap<Integer, Niec_Sensors> equipMap) {
        //查询目前上传的变压器局部放电的id   记录变压器局部放电上传的id大小
        Upload_check upload_check = upload_checkDao.selectByPrimaryKey(Constant.BYQJBFDID);
        BigInteger value = null;
        if (upload_check == null) {
            value = BigInteger.valueOf(0);
        } else {
            value = upload_check.getValue();
            if (value == null) {
                value = BigInteger.valueOf(0);
            }
        }
//        Boolean iscontiue = true;
//        while (iscontiue) {
            List<Data_Byq_Jbfd> data_byq_jbfdlist = data_byq_jbfdDao.selectUploadById(value);
            if (CollectionUtil.isNotEmpty(data_byq_jbfdlist)) {
                log.info("查询byq_jbfd的数据量：" + data_byq_jbfdlist.size());
                log.info("查询byq_jbfd的数据量 sendlimit ：" + sendlimit);
//                if (data_byq_jbfdlist.size() < 1000) {
//                    iscontiue = false;
//                }
//                BigDecimal add = NumberUtil.add(value, data_byq_jbfdlist.size());
//                value = add.toBigInteger();
                ArrayList<String> cacdatalist = new ArrayList<>();
        BigInteger maxid = value;

                for (int index = 0; index < data_byq_jbfdlist.size(); index++) {
                    Data_Byq_Jbfd item = data_byq_jbfdlist.get(index);
                    BigInteger ids = item.getId();
                    if (ids != null) {
                        int i = ids.compareTo(maxid);
                        if (i == 1) {
                            maxid = ids;
                        }
                    }
                    Niec_Sensors sensors = equipMap.get(item.getEqmid());
                    if (sensors == null) {
                        continue;
                    }
                    String sensorid = sensors.getSensorCode();
                    String equipmentid = sensors.getEquipmentId();
                    String phase = sensors.getPhase();
                    if (StrUtil.isNotEmpty(sensorid) && StrUtil.isNotEmpty(equipmentid)) {
                        ArrayList<AttrBean> attrlist = new ArrayList<>();
                        try {
                            String timestamp = "";
                            Date acquisitiontime = item.getAcquisitiontime();
                            if (acquisitiontime != null) {
                                timestamp = DateUtil.format(acquisitiontime, DatePattern.NORM_DATETIME_PATTERN);
                            }
                            if (phase != null) {
                                AttrBean<String> attr = new AttrBean<>();
                                attr.setKey("Phase");
                                attr.setValue(phase);
                                attrlist.add(attr);
                            }
                            Float dischargecapacity = item.getDischargecapacity();
                            if (dischargecapacity != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("DischargeCapacity");
                                attr.setValue(dischargecapacity);
                                attrlist.add(attr);
                            }
                            Float dischargeposition = item.getDischargeposition();
                            if (dischargeposition != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("DischargePosition");
                                attr.setValue(dischargeposition);
                                attrlist.add(attr);
                            }
                            Float pulsecount = item.getPulsecount();
                            if (pulsecount != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("PulseCount");
                                attr.setValue(pulsecount);
                                attrlist.add(attr);
                            }
                            byte[] dischargewaveform = item.getDischargewaveform();
                            if (dischargewaveform != null) {
                                AttrBean<byte[]> attr = new AttrBean<>();
                                attr.setKey("DischargeWaveform");
                                attr.setValue(dischargewaveform);
                                attrlist.add(attr);
                            }
                            String cacdata = GenerateI2Xml.generateCacXml(Constant.BYQ_JBFD, sensorid, equipmentid, timestamp, attrlist);
                            cacdatalist.add(cacdata);
                            BigInteger id = item.getId();
                            SendDataBean sendDataBean = new SendDataBean();
                            sendDataBean.setEqmid(item.getEqmid());
                            sendDataBean.setMaxid(id);
                            if ((index != 0 && index % sendlimit == 0) || index == (data_byq_jbfdlist.size() - 1)) {
                                String xml = GenerateI2Xml.generateEndCacXml(cacdatalist);
                                asyncMethod.sendData2(client, xml);
                                cacdatalist = new ArrayList<>();
                            }
                        } catch (Exception e) {
                            log.error("抛出了异常：{}" + e.getMessage());
                        }
                    }
                }
        asyncMethod.updateRecordId(maxid, Constant.BYQJBFDID);
            } else {
//                iscontiue = false;
                log.info("没有查询byq_jbfd的数据量");
            }
//        }
    }

    @Override
    public void upload_cnj(Client client, HashMap<Integer, Niec_Sensors> equipMap) {
//        Boolean iscontiue = true;
//        while (iscontiue) {
            Upload_check upload_check = upload_checkDao.selectByPrimaryKey(Constant.CNJID);
            BigInteger value = null;
            if (upload_check == null) {
                value = BigInteger.valueOf(0);
            } else {
                value = upload_check.getValue();
                if (value == null) {
                    value = BigInteger.valueOf(0);
                }
            }
            List<Data_Cnj> list = data_cnjDao.selectUploadById(value);
            if (CollectionUtil.isNotEmpty(list)) {
                log.info("查询cnj的数据量：" + list.size());
                log.info("查询cnj的数据量 sendlimit ：" + sendlimit);
//                if (list.size() < 1000) {
//                    iscontiue = false;
//                }
                ArrayList<String> cacdatalist = new ArrayList<>();
                BigInteger maxid = value;
                for (int index = 0; index < list.size(); index++) {
                    Data_Cnj item = list.get(index);
                    BigInteger ids = item.getId();
                    if (ids != null) {
                        int i = ids.compareTo(maxid);
                        if (i == 1) {
                            maxid = ids;
                        }
                    }
                    Niec_Sensors sensors = equipMap.get(item.getEqmid());
                    if (sensors == null) {
                        continue;
                    }
                    String sensorid = sensors.getSensorCode();
                    String equipmentid = sensors.getEquipmentId();
                    String phase = sensors.getPhase();
                    if (StrUtil.isNotEmpty(sensorid) && StrUtil.isNotEmpty(equipmentid)) {
                        ArrayList<AttrBean> attrlist = new ArrayList<>();
                        try {
                            String timestamp = "";
                            Date acquisitiontime = item.getAcquisitiontime();
                            if (acquisitiontime != null) {
                                timestamp = DateUtil.format(acquisitiontime, DatePattern.NORM_DATETIME_PATTERN);
                            }
                            if (phase != null) {
                                AttrBean<String> attr = new AttrBean<>();
                                attr.setKey("Phase");
                                attr.setValue(phase);
                                attrlist.add(attr);
                            }
                            Float chargetime = item.getChargetime();
                            if (chargetime != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("ChargeTime");
                                attr.setValue(chargetime);
                                attrlist.add(attr);
                            }
                            String cacdata = GenerateI2Xml.generateCacXml(Constant.CNJ, sensorid, equipmentid, timestamp, attrlist);
                            cacdatalist.add(cacdata);
                            if ((index != 0 && index % sendlimit == 0) || index == (list.size() - 1)) {
                                String xml = GenerateI2Xml.generateEndCacXml(cacdatalist);
                                asyncMethod.sendData2(client, xml);
                                cacdatalist = new ArrayList<>();
                            }
                        } catch (Exception e) {
                            log.error("抛出了异常：{}" + e.getMessage());
                        }
                    }
                }
                asyncMethod.updateRecordId(maxid, Constant.CNJID);
            } else {
//                iscontiue = false;
                log.info("没有查询cnj的数据量");
            }
//        }
    }

    @Override
    public void upload_dcyw(Client client, HashMap<Integer, Niec_Sensors> equipMap) {
//        Boolean iscontiue = true;
//        while (iscontiue) {
            Upload_check upload_check = upload_checkDao.selectByPrimaryKey(Constant.DCYWID);
            BigInteger value = null;
            if (upload_check == null) {
                value = BigInteger.valueOf(0);
            } else {
                value = upload_check.getValue();
                if (value == null) {
                    value = BigInteger.valueOf(0);
                }
            }
            List<Data_Dcyw> list = data_dcywDao.selectUploadById(value);
            if (CollectionUtil.isNotEmpty(list)) {
                log.info("查询dcyw的数据量：" + list.size());
//                if (list.size() < 1000) {
//                    iscontiue = false;
//                }
                ArrayList<String> cacdatalist = new ArrayList<>();
                BigInteger maxid = value;
                for (int index = 0; index < list.size(); index++) {
                    Data_Dcyw item = list.get(index);
                    BigInteger ids = item.getId();
                    if (ids != null) {
                        int i = ids.compareTo(maxid);
                        if (i == 1) {
                            maxid = ids;
                        }
                    }
                    Niec_Sensors sensors = equipMap.get(item.getEqmid());
                    if (sensors == null) {
                        continue;
                    }
                    String sensorid = sensors.getSensorCode();
                    String equipmentid = sensors.getEquipmentId();
                    String phase = sensors.getPhase();
                    if (StrUtil.isNotEmpty(sensorid) && StrUtil.isNotEmpty(equipmentid)) {
                        ArrayList<AttrBean> attrlist = new ArrayList<>();
                        try {
                            String timestamp = "";
                            Date acquisitiontime = item.getAcquisitiontime();
                            if (acquisitiontime != null) {
                                timestamp = DateUtil.format(acquisitiontime, DatePattern.NORM_DATETIME_PATTERN);
                            }
                            if (phase != null) {
                                AttrBean<String> attr = new AttrBean<>();
                                attr.setKey("Phase");
                                attr.setValue(phase);
                                attrlist.add(attr);
                            }
                            Float oiltemperature = item.getOiltemperature();
                            if (oiltemperature != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("OilTemperature");
                                attr.setValue(oiltemperature);
                                attrlist.add(attr);
                            }
                            String cacdata = GenerateI2Xml.generateCacXml(Constant.DCYW, sensorid, equipmentid, timestamp, attrlist);
                            cacdatalist.add(cacdata);
                            if ((index != 0 && index % sendlimit == 0) || index == (list.size() - 1)) {
                                String xml = GenerateI2Xml.generateEndCacXml(cacdatalist);
                                asyncMethod.sendData2(client, xml);
                                cacdatalist = new ArrayList<>();
                            }
                        } catch (Exception e) {
                            log.error("抛出了异常：{}" + e.getMessage());
                        }
                    }
                }
                asyncMethod.updateRecordId(maxid, Constant.DCYWID);
            } else {
//                iscontiue = false;
                log.info("没有查询dcyw的数据量");
            }
//        }
    }

    @Override
    public void upload_dlq_jbfd(Client client, HashMap<Integer, Niec_Sensors> equipMap) {
//        Boolean iscontiue = true;
//        while (iscontiue) {
            Upload_check upload_check = upload_checkDao.selectByPrimaryKey(Constant.DLQJBFDID);
            BigInteger value = null;
            if (upload_check == null) {
                value = BigInteger.valueOf(0);
            } else {
                value = upload_check.getValue();
                if (value == null) {
                    value = BigInteger.valueOf(0);
                }
            }
            List<Data_Dlq_Jbfd> list = data_dlq_jbfdDao.selectUploadById(value);
            if (CollectionUtil.isNotEmpty(list)) {
                log.info("查询dlq_jbfd的数据量：" + list.size());
                log.info("查询dlq_jbfd的数据量 sendlimit ：" + sendlimit);
//                if (list.size() < 1000) {
//                    iscontiue = false;
//                }
                ArrayList<String> cacdatalist = new ArrayList<>();
                BigInteger maxid = value;
                for (int index = 0; index < list.size(); index++) {
                    Data_Dlq_Jbfd item = list.get(index);
                    BigInteger ids = item.getId();
                    if (ids != null) {
                        int i = ids.compareTo(maxid);
                        if (i == 1) {
                            maxid = ids;
                        }
                    }
                    Niec_Sensors sensors = equipMap.get(item.getEqmid());
                    if (sensors == null) {
                        continue;
                    }
                    String sensorid = sensors.getSensorCode();
                    String equipmentid = sensors.getEquipmentId();
                    String phase = sensors.getPhase();
                    if (StrUtil.isNotEmpty(sensorid) && StrUtil.isNotEmpty(equipmentid)) {
                        ArrayList<AttrBean> attrlist = new ArrayList<>();
                        try {
                            String timestamp = "";
                            Date acquisitiontime = item.getAcquisitiontime();
                            if (acquisitiontime != null) {
                                timestamp = DateUtil.format(acquisitiontime, DatePattern.NORM_DATETIME_PATTERN);
                            }
                            if (phase != null) {
                                AttrBean<String> attr = new AttrBean<>();
                                attr.setKey("Phase");
                                attr.setValue(phase);
                                attrlist.add(attr);
                            }
                            Float dischargecapacity = item.getDischargecapacity();
                            if (dischargecapacity != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("DischargeCapacity");
                                attr.setValue(dischargecapacity);
                                attrlist.add(attr);
                            }
                            Float dischargeposition = item.getDischargeposition();
                            if (dischargeposition != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("DischargePosition");
                                attr.setValue(dischargeposition);
                                attrlist.add(attr);
                            }
                            Float pulsecount = item.getPulsecount();
                            if (pulsecount != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("PulseCount");
                                attr.setValue(pulsecount);
                                attrlist.add(attr);
                            }
                            byte[] dischargewaveform = item.getDischargewaveform();
                            if (dischargewaveform != null) {
                                AttrBean<byte[]> attr = new AttrBean<>();
                                attr.setKey("DischargeWaveform");
                                attr.setValue(dischargewaveform);
                                attrlist.add(attr);
                            }
                            String cacdata = GenerateI2Xml.generateCacXml(Constant.DLQJBFD, sensorid, equipmentid, timestamp, attrlist);
                            cacdatalist.add(cacdata);
                            if ((index != 0 && index % sendlimit == 0) || index == (list.size() - 1)) {
                                String xml = GenerateI2Xml.generateEndCacXml(cacdatalist);
                                asyncMethod.sendData2(client, xml);
                                cacdatalist = new ArrayList<>();
                            }
                        } catch (Exception e) {
                            log.error("抛出了异常：{}" + e.getMessage());
                        }
                    }
                }
                asyncMethod.updateRecordId(maxid, Constant.DLQJBFDID);
            } else {
//                iscontiue = false;
                log.info("没有查询到dlq的数据");
            }
//        }
    }

    @Override
    public void upload_dr_jyjc(Client client, HashMap<Integer, Niec_Sensors> equipMap) {
//        Boolean iscontiue = true;
//        while (iscontiue) {
            Upload_check upload_check = upload_checkDao.selectByPrimaryKey(Constant.DRJYJCID);
            BigInteger value = null;
            if (upload_check == null) {
                value = BigInteger.valueOf(0);
            } else {
                value = upload_check.getValue();
                if (value == null) {
                    value = BigInteger.valueOf(0);
                }
            }
            List<Data_Dr_Jyjc> list = data_dr_jyjcDao.selectUploadById(value);
            if (CollectionUtil.isNotEmpty(list)) {
                log.info("查询dr_jyjc的数据量：" + list.size());
//                if (list.size() < 1000) {
//                    iscontiue = false;
//                }
                ArrayList<String> cacdatalist = new ArrayList<>();
                BigInteger maxid = value;


                for (int index = 0; index < list.size(); index++) {
                    Data_Dr_Jyjc item = list.get(index);
                    BigInteger ids = item.getId();
                    if (ids != null) {
                        int i = ids.compareTo(maxid);
                        if (i == 1) {
                            maxid = ids;
                        }
                    }
                    Niec_Sensors sensors = equipMap.get(item.getEqmid());
                    if (sensors == null) {
                        continue;
                    }
                    String sensorid = sensors.getSensorCode();
                    String equipmentid = sensors.getEquipmentId();
                    String phase = sensors.getPhase();
                    if (StrUtil.isNotEmpty(sensorid) && StrUtil.isNotEmpty(equipmentid)) {
                        ArrayList<AttrBean> attrlist = new ArrayList<>();
                        try {
                            String timestamp = "";
                            Date acquisitiontime = item.getAcquisitiontime();
                            if (acquisitiontime != null) {
                                timestamp = DateUtil.format(acquisitiontime, DatePattern.NORM_DATETIME_PATTERN);
                            }
                            if (phase != null) {
                                AttrBean<String> attr = new AttrBean<>();
                                attr.setKey("Phase");
                                attr.setValue(phase);
                                attrlist.add(attr);
                            }
                            Float capacitance = item.getCapacitance();
                            if (capacitance != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("Capacitance");
                                attr.setValue(capacitance);
                                attrlist.add(attr);
                            }
                            Float lossfactor = item.getLossfactor();
                            if (lossfactor != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("LossFactor");
                                attr.setValue(lossfactor);
                                attrlist.add(attr);
                            }
                            Float unbalancecurrent = item.getUnbalancecurrent();
                            if (unbalancecurrent != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("UnbalanceCurrent");
                                attr.setValue(unbalancecurrent);
                                attrlist.add(attr);
                            }
                            Float unbalancevoltage = item.getUnbalancevoltage();
                            if (unbalancevoltage != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("UnbalanceVoltage");
                                attr.setValue(unbalancevoltage);
                                attrlist.add(attr);
                            }
                            Float totalcurrent = item.getTotalcurrent();
                            if (totalcurrent != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("TotalCurrent");
                                attr.setValue(totalcurrent);
                                attrlist.add(attr);
                            }
                            Float systemvoltage = item.getSystemvoltage();
                            if (systemvoltage != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("SystemVoltage");
                                attr.setValue(systemvoltage);
                                attrlist.add(attr);
                            }
                            String cacdata = GenerateI2Xml.generateCacXml(Constant.DRJYJC, sensorid, equipmentid, timestamp, attrlist);
                            cacdatalist.add(cacdata);
                            if ((index != 0 && index % sendlimit == 0) || index == (list.size() - 1)) {
                                ArrayList<BigInteger> list1 = new ArrayList<>();
                                String xml = GenerateI2Xml.generateEndCacXml(cacdatalist);
                                asyncMethod.sendData2(client, xml);
                                cacdatalist = new ArrayList<>();
                            }
                        } catch (Exception e) {
                            log.error("抛出了异常：{}" + e.getMessage());
                        }
                    }
                }
                asyncMethod.updateRecordId(maxid, Constant.DRJYJCID);
            } else {
//                iscontiue = false;
                log.info("没有查询dr_jyjc的数据量");
            }
//        }
    }

    @Override
    public void upload_fhdlbx(Client client, HashMap<Integer, Niec_Sensors> equipMap) {
//        Boolean iscontiue = true;
//        while (iscontiue) {
            Upload_check upload_check = upload_checkDao.selectByPrimaryKey(Constant.FHDLBXID);
            BigInteger value = null;
            if (upload_check == null) {
                value = BigInteger.valueOf(0);
            } else {
                value = upload_check.getValue();
                if (value == null) {
                    value = BigInteger.valueOf(0);
                }
            }
            List<Data_Fhdlbx> list = data_fhdlbxDao.selectUploadById(value);
            if (CollectionUtil.isNotEmpty(list)) {
                log.info("查询fhdlbx的数据量：" + list.size());
//                if (list.size()<1000) {
//                    iscontiue = false;
//                }
                ArrayList<String> cacdatalist = new ArrayList<>();
                BigInteger maxid = value;
                for (int index = 0; index < list.size(); index++) {
                    Data_Fhdlbx item = list.get(index);
                    BigInteger ids = item.getId();
                    if (ids != null) {
                        int i = ids.compareTo(maxid);
                        if (i == 1) {
                            maxid = ids;
                        }
                    }
                    Niec_Sensors sensors = equipMap.get(item.getEqmid());
                    if (sensors == null) {
                        continue;
                    }
                    String sensorid = sensors.getSensorCode();
                    String equipmentid = sensors.getEquipmentId();
                    String phase = sensors.getPhase();
                    if (StrUtil.isNotEmpty(sensorid) && StrUtil.isNotEmpty(equipmentid)) {
                        ArrayList<AttrBean> attrlist = new ArrayList<>();
                        try {
                            String timestamp = "";
                            Date acquisitiontime = item.getAcquisitiontime();
                            if (acquisitiontime != null) {
                                timestamp = DateUtil.format(acquisitiontime, DatePattern.NORM_DATETIME_PATTERN);
                            }
                            if (phase != null) {
                                AttrBean<String> attr = new AttrBean<>();
                                attr.setKey("Phase");
                                attr.setValue(phase);
                                attrlist.add(attr);
                            }
                            Integer action = item.getAction();
                            if (action != null) {
                                AttrBean<Integer> attr = new AttrBean<>();
                                attr.setKey("Action");
                                attr.setValue(action);
                                attrlist.add(attr);
                            }
                            byte[] loadwaveform = item.getLoadwaveform();
                            if (loadwaveform != null) {
                                AttrBean<byte[]> attr = new AttrBean<>();
                                attr.setKey("LoadWaveform");
                                attr.setValue(loadwaveform);
                                attrlist.add(attr);
                            }
                            String cacdata = GenerateI2Xml.generateCacXml(Constant.FHDLBX, sensorid, equipmentid, timestamp, attrlist);
                            cacdatalist.add(cacdata);
                            if ((index != 0 && index % sendlimit == 0) || index == (list.size() - 1)) {
                                String xml = GenerateI2Xml.generateEndCacXml(cacdatalist);
                                asyncMethod.sendData2(client, xml);
                                cacdatalist = new ArrayList<>();
                            }
                        } catch (Exception e) {
                            log.error("抛出了异常：{}" + e.getMessage());
                        }
                    }
                }
                asyncMethod.updateRecordId(maxid, Constant.FHDLBXID);
            } else {
//                iscontiue = false;
                log.info("没有查询fhdlbx的数据量");
            }
//        }
    }

    @Override
    public void upload_fhzxq(Client client, HashMap<Integer, Niec_Sensors> equipMap) {
//        Boolean iscontiue = true;
//        while (iscontiue) {
            Upload_check upload_check = upload_checkDao.selectByPrimaryKey(Constant.FHZXQID);
            BigInteger value = null;
            if (upload_check == null) {
                value = BigInteger.valueOf(0);
            } else {
                value = upload_check.getValue();
                if (value == null) {
                    value = BigInteger.valueOf(0);
                }
            }
            List<Data_Fhzxq> list = data_fhzxqDao.selectUploadById(value);
            if (CollectionUtil.isNotEmpty(list)) {
                log.info("查询fhzxq的数据量：" + list.size());
//                if (list.size()<1000) {
//                    iscontiue = false;
//                }
                ArrayList<String> cacdatalist = new ArrayList<>();
                BigInteger maxid = value;
                for (int index = 0; index < list.size(); index++) {
                    Data_Fhzxq item = list.get(index);
                    BigInteger ids = item.getId();
                    if (ids != null) {
                        int i = ids.compareTo(maxid);
                        if (i == 1) {
                            maxid = ids;
                        }
                    }
                    Niec_Sensors sensors = equipMap.get(item.getEqmid());
                    if (sensors == null) {
                        continue;
                    }
                    String sensorid = sensors.getSensorCode();
                    String equipmentid = sensors.getEquipmentId();
                    String phase = sensors.getPhase();
                    if (StrUtil.isNotEmpty(sensorid) && StrUtil.isNotEmpty(equipmentid)) {
                        ArrayList<AttrBean> attrlist = new ArrayList<>();
                        try {
                            String timestamp = "";
                            Date acquisitiontime = item.getAcquisitiontime();
                            if (acquisitiontime != null) {
                                timestamp = DateUtil.format(acquisitiontime, DatePattern.NORM_DATETIME_PATTERN);
                            }
                            if (phase != null) {
                                AttrBean<String> attr = new AttrBean<>();
                                attr.setKey("Phase");
                                attr.setValue(phase);
                                attrlist.add(attr);
                            }
                            Integer action = item.getAction();
                            if (action != null) {
                                AttrBean<Integer> attr = new AttrBean<>();
                                attr.setKey("Action");
                                attr.setValue(action);
                                attrlist.add(attr);
                            }
                            byte[] coilwaveform = item.getCoilwaveform();
                            if (coilwaveform != null) {
                                AttrBean<byte[]> attr = new AttrBean<>();
                                attr.setKey("CoilWaveform");
                                attr.setValue(coilwaveform);
                                attrlist.add(attr);
                            }
                            String cacdata = GenerateI2Xml.generateCacXml(Constant.FHZXQ, sensorid, equipmentid, timestamp, attrlist);
                            cacdatalist.add(cacdata);
                            if ((index != 0 && index % sendlimit == 0) || index == (list.size() - 1)) {
                                String xml = GenerateI2Xml.generateEndCacXml(cacdatalist);
                                asyncMethod.sendData2(client, xml);
                                cacdatalist = new ArrayList<>();
                            }
                        } catch (Exception e) {
                            log.error("抛出了异常：{}" + e.getMessage());
                        }
                    }
                }
                asyncMethod.updateRecordId(maxid, Constant.FHZXQID);
            } else {
//                iscontiue = false;
                log.info("没有查询fhzxq的数据量");
            }
//        }
    }

    @Override
    public void upload_jsyhw_jyjc(Client client, HashMap<Integer, Niec_Sensors> equipMap) {
//        Boolean iscontiue = true;
//        while (iscontiue) {
            Upload_check upload_check = upload_checkDao.selectByPrimaryKey(Constant.JSYHWJYJCID);
            BigInteger value = null;
            if (upload_check == null) {
                value = BigInteger.valueOf(0);
            } else {
                value = upload_check.getValue();
                if (value == null) {
                    value = BigInteger.valueOf(0);
                }
            }
            List<Data_Jsyhw_Jyjc> list = data_jsyhw_jyjcDao.selectUploadById(value);
            if (CollectionUtil.isNotEmpty(list)) {
                log.info("查询jsyhw_jyjc的数据量：" + list.size());
                log.info("查询jsyhw_jyjc的数据量 sendlimit ：" + sendlimit);
//                if (list.size()<1000) {
//                    iscontiue = false;
//                }
                ArrayList<String> cacdatalist = new ArrayList<>();
                BigInteger maxid = value;
                for (int index = 0; index < list.size(); index++) {
                    Data_Jsyhw_Jyjc item = list.get(index);
                    BigInteger ids = item.getId();
                    if (ids != null) {
                        int i = ids.compareTo(maxid);
                        if (i == 1) {
                            maxid = ids;
                        }
                    }
                    Niec_Sensors sensors = equipMap.get(item.getEqmid());
                    if (sensors == null) {
                        continue;
                    }
                    String sensorid = sensors.getSensorCode();
                    String equipmentid = sensors.getEquipmentId();
                    String phase = sensors.getPhase();
                    if (StrUtil.isNotEmpty(sensorid) && StrUtil.isNotEmpty(equipmentid)) {
                        ArrayList<AttrBean> attrlist = new ArrayList<>();
                        try {
                            String timestamp = "";
                            Date acquisitiontime = item.getAcquisitiontime();
                            if (acquisitiontime != null) {
                                timestamp = DateUtil.format(acquisitiontime, DatePattern.NORM_DATETIME_PATTERN);
                            }
                            if (phase != null) {
                                AttrBean<String> attr = new AttrBean<>();
                                attr.setKey("Phase");
                                attr.setValue(phase);
                                attrlist.add(attr);
                            }
                            Float systemvoltage = item.getSystemvoltage();
                            if (systemvoltage != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("SystemVoltage");
                                attr.setValue(systemvoltage);
                                attrlist.add(attr);
                            }
                            Float totalcurrent = item.getTotalcurrent();
                            if (totalcurrent != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("TotalCurrent");
                                attr.setValue(totalcurrent);
                                attrlist.add(attr);
                            }
                            Float resistivecurrent = item.getResistivecurrent();
                            if (resistivecurrent != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("ResistiveCurrent");
                                attr.setValue(resistivecurrent);
                                attrlist.add(attr);
                            }
                            Float actioncount = item.getActioncount();
                            if (actioncount != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("ActionCount");
                                attr.setValue(actioncount);
                                attrlist.add(attr);
                            }
                            Date lastactiontime = item.getLastactiontime();
                            if (lastactiontime != null) {
                                AttrBean<String> attr = new AttrBean<>();
                                attr.setKey("LastActionTime");
                                attr.setValue(DateUtil.format(lastactiontime, DatePattern.NORM_DATETIME_PATTERN));
                                attrlist.add(attr);
                            }
                            String cacdata = GenerateI2Xml.generateCacXml(Constant.JSYHW, sensorid, equipmentid, timestamp, attrlist);
                            cacdatalist.add(cacdata);
                            if ((index != 0 && index % sendlimit == 0) || index == (list.size() - 1)) {
                                String xml = GenerateI2Xml.generateEndCacXml(cacdatalist);
                                asyncMethod.sendData2(client, xml);
                                cacdatalist = new ArrayList<>();
                            }
                        } catch (Exception e) {
                            log.error("抛出了异常：{}" + e.getMessage());
                        }
                    }
                }
                asyncMethod.updateRecordId(maxid, Constant.JSYHWJYJCID);
            } else {
//                iscontiue = false;
                log.info("没有查询jsyhw_jyjc的数据量");
            }
//        }
    }

    @Override
    public void upload_sf6_qtsf(Client client, HashMap<Integer, Niec_Sensors> equipMap) {
//        Boolean iscontiue = true;
//        while (iscontiue) {
            Upload_check upload_check = upload_checkDao.selectByPrimaryKey(Constant.SF6QTSFID);
            BigInteger value = null;
            if (upload_check == null) {
                value = BigInteger.valueOf(0);
            } else {
                value = upload_check.getValue();
                if (value == null) {
                    value = BigInteger.valueOf(0);
                }
            }
            List<Data_SF6_Qtsf> list = data_sf6_qtsfDao.selectUploadById(value);
            if (CollectionUtil.isNotEmpty(list)) {
                log.info("查询sf6_qtsf的数据量：" + list.size());
//                if (list.size()<1000) {
//                    iscontiue = false;
//                }
                ArrayList<String> cacdatalist = new ArrayList<>();
                BigInteger maxid = value;
                for (int index = 0; index < list.size(); index++) {
                    Data_SF6_Qtsf item = list.get(index);
                    BigInteger ids = item.getId();
                    if (ids != null) {
                        int i = ids.compareTo(maxid);
                        if (i == 1) {
                            maxid = ids;
                        }
                    }
                    Niec_Sensors sensors = equipMap.get(item.getEqmid());
                    if (sensors == null) {
                        continue;
                    }
                    String sensorid = sensors.getSensorCode();
                    String equipmentid = sensors.getEquipmentId();
                    String phase = sensors.getPhase();
                    if (StrUtil.isNotEmpty(sensorid) && StrUtil.isNotEmpty(equipmentid)) {
                        ArrayList<AttrBean> attrlist = new ArrayList<>();
                        try {
                            String timestamp = "";
                            Date acquisitiontime = item.getAcquisitiontime();
                            if (acquisitiontime != null) {
                                timestamp = DateUtil.format(acquisitiontime, DatePattern.NORM_DATETIME_PATTERN);
                            }
                            if (phase != null) {
                                AttrBean<String> attr = new AttrBean<>();
                                attr.setKey("Phase");
                                attr.setValue(phase);
                                attrlist.add(attr);
                            }
                            Float temperature = item.getTemperature();
                            if (temperature != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("Temperature");
                                attr.setValue(temperature);
                                attrlist.add(attr);
                            }
                            Float moisture = item.getMoisture();
                            if (moisture != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("Moisture");
                                attr.setValue(moisture);
                                attrlist.add(attr);
                            }
                            String cacdata = GenerateI2Xml.generateCacXml(Constant.SF6_QTSF, sensorid, equipmentid, timestamp, attrlist);
                            cacdatalist.add(cacdata);
                            if ((index != 0 && index % sendlimit == 0) || index == (list.size() - 1)) {
                                String xml = GenerateI2Xml.generateEndCacXml(cacdatalist);
                                asyncMethod.sendData2(client, xml);
                                cacdatalist = new ArrayList<>();
                            }
                        } catch (Exception e) {
                            log.error("抛出了异常：{}" + e.getMessage());
                        }
                    }
                }
                asyncMethod.updateRecordId(maxid, Constant.SF6QTSFID);
            } else {
//                iscontiue = false;
                log.info("没有查询sf6_qtsf的数据量");
            }
//        }
    }

    @Override
    public void upload_sf6_qtyl(Client client, HashMap<Integer, Niec_Sensors> equipMap) {
//        Boolean iscontiue = true;
//        while (iscontiue) {
            Upload_check upload_check = upload_checkDao.selectByPrimaryKey(Constant.SF6QTYLID);
            BigInteger value = null;
            if (upload_check == null) {
                value = BigInteger.valueOf(0);
            }else {
                value = upload_check.getValue();
                if (value == null) {
                    value = BigInteger.valueOf(0);
                }
            }
            List<Data_SF6_Qtyl> list = data_sf6_qtylDao.selectUploadById(value);
            if (CollectionUtil.isNotEmpty(list)) {
                log.info("查询sf6_qtyl的数据量：" + list.size());
//                if (list.size()<1000) {
//                    iscontiue = false;
//                }
                ArrayList<String> cacdatalist = new ArrayList<>();
                BigInteger maxid = value;
                for (int index = 0; index < list.size(); index++) {
                    Data_SF6_Qtyl item = list.get(index);
                    BigInteger ids = item.getId();
                    if (ids != null) {
                        int i = ids.compareTo(maxid);
                        if (i == 1) {
                            maxid = ids;
                        }
                    }
                    Niec_Sensors sensors = equipMap.get(item.getEqmid());
                    if (sensors == null) {
                        continue;
                    }
                    String sensorid = sensors.getSensorCode();
                    String equipmentid = sensors.getEquipmentId();
                    String phase = sensors.getPhase();
                    if (StrUtil.isNotEmpty(sensorid) && StrUtil.isNotEmpty(equipmentid)) {
                        ArrayList<AttrBean> attrlist = new ArrayList<>();
                        try {
                            String timestamp = "";
                            Date acquisitiontime = item.getAcquisitiontime();
                            if (acquisitiontime != null) {
                                timestamp = DateUtil.format(acquisitiontime, DatePattern.NORM_DATETIME_PATTERN);
                            }
                            if (phase != null) {
                                AttrBean<String> attr = new AttrBean<>();
                                attr.setKey("Phase");
                                attr.setValue(phase);
                                attrlist.add(attr);
                            }
                            Float temperature = item.getTemperature();
                            if (temperature != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("Temperature");
                                attr.setValue(temperature);
                                attrlist.add(attr);
                            }
                            Float absolutepressure = item.getAbsolutepressure();
                            if (absolutepressure != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("AbsolutePressure");
                                attr.setValue(absolutepressure);
                                attrlist.add(attr);
                            }
                            Float density = item.getDensity();
                            if (density != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("Density");
                                attr.setValue(density);
                                attrlist.add(attr);
                            }
                            Float pressure20c = item.getPressure20c();
                            if (pressure20c != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("Pressure20C");
                                attr.setValue(pressure20c);
                                attrlist.add(attr);
                            }
                            String cacdata = GenerateI2Xml.generateCacXml(Constant.SF6_QTYL, sensorid, equipmentid, timestamp, attrlist);
                            cacdatalist.add(cacdata);
                            if ((index != 0 && index % sendlimit == 0) || index == (list.size() - 1)) {
                                log.info("开始传输");
                                String xml = GenerateI2Xml.generateEndCacXml(cacdatalist);
                                asyncMethod.sendData2(client, xml);
                                cacdatalist = new ArrayList<>();
                            }
                        } catch (Exception e) {
                            log.error("抛出了异常：{}" + e.getMessage());
                        }
                    }
                }
                asyncMethod.updateRecordId(maxid, Constant.SF6QTYLID);
            } else {
//                iscontiue = false;
                log.info("没有查询到sf6_qtyl的数据");
            }
//        }
    }

    @Override
    public void upload_tx(Client client, HashMap<Integer, Niec_Sensors> equipMap) {
//        Boolean iscontiue = true;
//        while (iscontiue) {
            Upload_check upload_check = upload_checkDao.selectByPrimaryKey(Constant.TXID);
            BigInteger value = null;
            if (upload_check == null) {
                value = BigInteger.valueOf(0);
            } else {
                value = upload_check.getValue();
                if (value == null) {
                    value = BigInteger.valueOf(0);
                }
            }
            List<Data_Tx> list = data_txDao.selectUploadById(value);
            if (CollectionUtil.isNotEmpty(list)) {
                log.info("查询tx的数据量：" + list.size());
//                if (list.size()<1000) {
//                    iscontiue = false;
//                }
                ArrayList<String> cacdatalist = new ArrayList<>();
                BigInteger maxid = value;
                for (int index = 0; index < list.size(); index++) {
                    Data_Tx item = list.get(index);
                    BigInteger ids = item.getId();
                    if (ids != null) {
                        int i = ids.compareTo(maxid);
                        if (i == 1) {
                            maxid = ids;
                        }
                    }
                    Niec_Sensors sensors = equipMap.get(item.getEqmid());
                    if (sensors == null) {
                        continue;
                    }
                    String sensorid = sensors.getSensorCode();
                    String equipmentid = sensors.getEquipmentId();
                    String phase = sensors.getPhase();
                    if (StrUtil.isNotEmpty(sensorid) && StrUtil.isNotEmpty(equipmentid)) {
                        ArrayList<AttrBean> attrlist = new ArrayList<>();
                        try {
                            String timestamp = "";
                            Date acquisitiontime = item.getAcquisitiontime();
                            if (acquisitiontime != null) {
                                timestamp = DateUtil.format(acquisitiontime, DatePattern.NORM_DATETIME_PATTERN);
                            }
                            if (phase != null) {
                                AttrBean<String> attr = new AttrBean<>();
                                attr.setKey("Phase");
                                attr.setValue(phase);
                                attrlist.add(attr);
                            }
                            Float totalcorecurrent = item.getTotalcorecurrent();
                            if (totalcorecurrent != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("TotalCoreCurrent");
                                attr.setValue(totalcorecurrent);
                                attrlist.add(attr);
                            }
                            String cacdata = GenerateI2Xml.generateCacXml(Constant.TX, sensorid, equipmentid, timestamp, attrlist);
                            cacdatalist.add(cacdata);
                            if ((index != 0 && index % sendlimit == 0) || index == (list.size() - 1)) {
                                String xml = GenerateI2Xml.generateEndCacXml(cacdatalist);
                                asyncMethod.sendData2(client, xml);
                                cacdatalist = new ArrayList<>();
                            }
                        } catch (Exception e) {
                            log.error("抛出了异常：{}" + e.getMessage());
                        }
                    }
                }
                asyncMethod.updateRecordId(maxid, Constant.TXID);
            } else {
//                iscontiue = false;
                log.info("没有查询到tx的数据");
            }
//        }
    }

    @Override
    public void upload_ws(Client client, HashMap<Integer, Niec_Sensors> equipMap) {
//        Boolean iscontiue = true;
//        while (iscontiue) {
            Upload_check upload_check = upload_checkDao.selectByPrimaryKey(Constant.WSID);
            BigInteger value = null;
            if (upload_check == null) {
                value = BigInteger.valueOf(0);
            } else {
                value = upload_check.getValue();
                if (value == null) {
                    value = BigInteger.valueOf(0);
                }
            }
            List<Data_Ws> list = data_wsDao.selectUploadById(value);
            if (CollectionUtil.isNotEmpty(list)) {
                log.info("查询ws的数据量：" + list.size());
//                if (list.size()<1000) {
//                    iscontiue = false;
//                }
                ArrayList<String> cacdatalist = new ArrayList<>();
                BigInteger maxid = value;
                for (int index = 0; index < list.size(); index++) {
                    Data_Ws item = list.get(index);
                    BigInteger ids = item.getId();
                    if (ids != null) {
                        int i = ids.compareTo(maxid);
                        if (i == 1) {
                            maxid = ids;
                        }
                    }
                    Niec_Sensors sensors = equipMap.get(item.getEqmid());
                    if (sensors == null) {
                        continue;
                    }
                    String sensorid = sensors.getSensorCode();
                    String equipmentid = sensors.getEquipmentId();
                    String phase = sensors.getPhase();
                    if (StrUtil.isNotEmpty(sensorid) && StrUtil.isNotEmpty(equipmentid)) {
                        ArrayList<AttrBean> attrlist = new ArrayList<>();
                        try {
                            String timestamp = "";
                            Date acquisitiontime = item.getAcquisitiontime();
                            if (acquisitiontime != null) {
                                timestamp = DateUtil.format(acquisitiontime, DatePattern.NORM_DATETIME_PATTERN);
                            }
                            if (phase != null) {
                                AttrBean<String> attr = new AttrBean<>();
                                attr.setKey("Phase");
                                attr.setValue(phase);
                                attrlist.add(attr);
                            }
                            Float moisture = item.getMoisture();
                            if (moisture != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("Moisture");
                                attr.setValue(moisture);
                                attrlist.add(attr);
                            }
                            String cacdata = GenerateI2Xml.generateCacXml(Constant.WS, sensorid, equipmentid, timestamp, attrlist);
                            cacdatalist.add(cacdata);
                            if ((index != 0 && index % sendlimit == 0) || index == (list.size() - 1)) {
                                String xml = GenerateI2Xml.generateEndCacXml(cacdatalist);
                                asyncMethod.sendData2(client, xml);
                                cacdatalist = new ArrayList<>();
                            }
                        } catch (Exception e) {
                            log.error("抛出了异常：{}" + e.getMessage());
                        }
                    }
                }
                asyncMethod.updateRecordId(maxid, Constant.WSID);
            } else {
//                iscontiue = false;
                log.info("没有查询到ws的数据");
            }
//        }
    }

    @Override
    public void upload_ysp(Client client, HashMap<Integer, Niec_Sensors> equipMap) {
//        Boolean iscontiue = true;
//        while (iscontiue) {
            //查询目前上传的油色谱的id   记录油色谱上传的id大小
            Upload_check upload_check = upload_checkDao.selectByPrimaryKey(Constant.YSPID);
            BigInteger value = null;
            if (upload_check == null) {
                value = BigInteger.valueOf(0);
            } else {
                value = upload_check.getValue();
                if (value == null) {
                    value = BigInteger.valueOf(0);
                }
            }
            List<Data_Ysp> list = data_yspDao.selectUploadById(value);
            if (CollectionUtil.isNotEmpty(list)) {
                log.info("查询ysp的数据量：" + list.size());
//                if (list.size()<1000) {
//                    iscontiue = false;
//                }
                ArrayList<String> cacdatalist = new ArrayList<>();
                BigInteger maxid = value;
                for (int index = 0; index < list.size(); index++) {
                    Data_Ysp item = list.get(index);
                    BigInteger ids = item.getId();
                    if (ids != null) {
                        int i = ids.compareTo(maxid);
                        if (i == 1) {
                            maxid = ids;
                        }
                    }
                    Niec_Sensors sensors = equipMap.get(item.getEqmid());
                    if (sensors == null) {
                        continue;
                    }
                    String sensorid = sensors.getSensorCode();
                    String equipmentid = sensors.getEquipmentId();
                    String phase = sensors.getPhase();
                    if (StrUtil.isNotEmpty(sensorid) && StrUtil.isNotEmpty(equipmentid)) {
                        ArrayList<AttrBean> attrlist = new ArrayList<>();
                        try {
                            String timestamp = "";
                            Date acquisitiontime = item.getAcquisitiontime();
                            if (acquisitiontime != null) {
                                timestamp = DateUtil.format(acquisitiontime, DatePattern.NORM_DATETIME_PATTERN);
                            }
                            if (phase != null) {
                                AttrBean<String> attr = new AttrBean<>();
                                attr.setKey("Phase");
                                attr.setValue(phase);
                                attrlist.add(attr);
                            }
                            Float h2 = item.getH2();
                            if (h2 != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("H2");
                                attr.setValue(h2);
                                attrlist.add(attr);
                            }
                            Float ch4 = item.getCh4();
                            if (ch4 != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("CH4");
                                attr.setValue(ch4);
                                attrlist.add(attr);
                            }
                            Float c2h6 = item.getC2h6();
                            if (c2h6 != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("C2H6");
                                attr.setValue(c2h6);
                                attrlist.add(attr);
                            }
                            Float c2h4 = item.getC2h4();
                            if (c2h4 != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("C2H4");
                                attr.setValue(c2h4);
                                attrlist.add(attr);
                            }
                            Float c2h2 = item.getC2h2();
                            if (c2h2 != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("C2H2");
                                attr.setValue(c2h2);
                                attrlist.add(attr);
                            }
                            Float co = item.getCo();
                            if (co != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("CO");
                                attr.setValue(co);
                                attrlist.add(attr);
                            }
                            Float co2 = item.getCo2();
                            if (co2 != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("CO2");
                                attr.setValue(co2);
                                attrlist.add(attr);
                            }
                            Float o2 = item.getO2();
                            if (o2 != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("O2");
                                attr.setValue(o2);
                                attrlist.add(attr);
                            }
                            Float n2 = item.getN2();
                            if (n2 != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("N2");
                                attr.setValue(n2);
                                attrlist.add(attr);
                            }
                            Float totalhydrocarbon = item.getTotalhydrocarbon();
                            if (totalhydrocarbon != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("TotalHydrocarbon");
                                attr.setValue(totalhydrocarbon);
                                attrlist.add(attr);
                            }
                            String cacdata = GenerateI2Xml.generateCacXml(Constant.YSP, sensorid, equipmentid, timestamp, attrlist);
                            cacdatalist.add(cacdata);
                            log.info("测试断点3");
                            if ((index != 0 && index % sendlimit == 0) || index == (list.size() - 1)) {
                                log.info("测试断点4");
                                String xml = GenerateI2Xml.generateEndCacXml(cacdatalist);
                                log.info("ysp组装完成，开始上传");
                                asyncMethod.sendData2(client, xml);
                                cacdatalist = new ArrayList<>();
                            }
                        } catch (Exception e) {
                            log.error("抛出了异常：{}" + e.getMessage());
                        }
                    }
                }
                asyncMethod.updateRecordId(maxid, Constant.YSPID);
            } else {
//                iscontiue = false;
                log.info("没有查询到ysp的数据");
            }
//        }
    }

    @Override
    public void upload_microclimate(Client client, HashMap<Integer, Niec_Sensors> equipMap) {
//        Boolean iscontiue = true;
//        while (iscontiue) {
            Upload_check upload_check = upload_checkDao.selectByPrimaryKey(Constant.MICROCLIMATEID);
            BigInteger value = null;
            if (upload_check == null) {
                value = BigInteger.valueOf(0);
            } else {
                value = upload_check.getValue();
                if (value == null) {
                    value = BigInteger.valueOf(0);
                }
            }
            List<Data_Microclimate> list = data_microclimateDao.selectUploadById(value);
            if (CollectionUtil.isNotEmpty(list)) {
                log.info("查询microclimate的数据量：" + list.size());
//                if (list.size()<1000) {
//                    iscontiue = false;
//                }
                ArrayList<String> cacdatalist = new ArrayList<>();
                BigInteger maxid = value;
                for (int index = 0; index < list.size(); index++) {
                    Data_Microclimate item = list.get(index);
                    BigInteger ids = item.getId();
                    if (ids != null) {
                        int i = ids.compareTo(maxid);
                        if (i == 1) {
                            maxid = ids;
                        }
                    }
                    Niec_Sensors sensors = equipMap.get(item.getEqmid());
                    if (sensors == null) {
                        continue;
                    }
                    String sensorid = sensors.getSensorCode();
                    String equipmentid = sensors.getEquipmentId();
                    String phase = sensors.getPhase();
                    if (StrUtil.isNotEmpty(sensorid) && StrUtil.isNotEmpty(equipmentid)) {
                        ArrayList<AttrBean> attrlist = new ArrayList<>();
                        try {
                            String timestamp = "";
                            Date acquisitiontime = item.getAcquisitiontime();
                            if (acquisitiontime != null) {
                                timestamp = DateUtil.format(acquisitiontime, DatePattern.NORM_DATETIME_PATTERN);
                            }
                            if (phase != null) {
                                AttrBean<String> attr = new AttrBean<>();
                                attr.setKey("Phase");
                                attr.setValue(phase);
                                attrlist.add(attr);
                            }
                            Float airtemperature = item.getAirtemperature();
                            if (airtemperature != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("AirTemperature");
                                attr.setValue(airtemperature);
                                attrlist.add(attr);
                            }
                            Float airpressure = item.getAirpressure();
                            if (airpressure != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("AirPressure");
                                attr.setValue(airpressure);
                                attrlist.add(attr);
                            }
                            Float humidity = item.getHumidity();
                            if (humidity != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("Humidity");
                                attr.setValue(humidity);
                                attrlist.add(attr);
                            }
                            Float precipitation = item.getPrecipitation();
                            if (precipitation != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("Precipitation");
                                attr.setValue(precipitation);
                                attrlist.add(attr);
                            }
                            Float precipitationintensity = item.getPrecipitationintensity();
                            if (precipitationintensity != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("PrecipitationIntensity");
                                attr.setValue(precipitationintensity);
                                attrlist.add(attr);
                            }
                            Float radiationintensity = item.getRadiationintensity();
                            if (radiationintensity != null) {
                                AttrBean<Float> attr = new AttrBean<>();
                                attr.setKey("RadiationIntensity");
                                attr.setValue(radiationintensity);
                                attrlist.add(attr);
                            }
                            String cacdata = GenerateI2Xml.generateCacXml(Constant.WQX, sensorid, equipmentid, timestamp, attrlist);
                            cacdatalist.add(cacdata);
                            if ((index != 0 && index % sendlimit == 0) || index == (list.size() - 1)) {
                                String xml = GenerateI2Xml.generateEndCacXml(cacdatalist);
                                asyncMethod.sendData2(client, xml);
                                cacdatalist = new ArrayList<>();
                            }
                        } catch (Exception e) {
                            log.error("抛出了异常：{}" + e.getMessage());
                        }
                    }
                }
                asyncMethod.updateRecordId(maxid, Constant.MICROCLIMATEID);
            } else {
//                iscontiue = false;
                log.info("没有查询到microcimate的数据");
            }
//        }
    }

    @Override
    public void upload_yx(Client client) {
//        Boolean iscontiue = true;
//        while (iscontiue) {
            Upload_check upload_check = upload_checkDao.selectByPrimaryKey(Constant.YXID);
            BigInteger value = null;
            if (upload_check == null) {
                value = BigInteger.valueOf(0);
            } else {
                value = upload_check.getValue();
                if (value == null) {
                    value = BigInteger.valueOf(0);
                }
            }
            List<Data_YxlDto> list = data_yxDao.selectByPrimaryKey(value);
            if (CollectionUtil.isNotEmpty(list)) {
                log.info("查询yx的数据量：" + list.size());
//                if (list.size() < 1000) {
//                    iscontiue = false;
//                }
                BigInteger maxid = value;
                for (int index = 0; index < list.size(); index++) {
                    Data_YxlDto data_yxlDto = list.get(index);
                    Date dtime = data_yxlDto.getDtime();
                    String equipmentid = data_yxlDto.getEquipmentId();
                    String sensorid = data_yxlDto.getSensorCode();
                    String tableName = data_yxlDto.getTableName();
                    String field = data_yxlDto.getField();
                    Integer ival = data_yxlDto.getIval();
                    Integer sadr = data_yxlDto.getSadr();
                    String phase = data_yxlDto.getPhase();
                    BigInteger ids = data_yxlDto.getId();
                    if (ids != null) {
                        int i = ids.compareTo(maxid);
                        if (i == 1) {
                            maxid = ids;
                        }
                    }

                    YxAttrBean<Integer> attr = new YxAttrBean<>();
                    attr.setSensorid(sensorid);
                    attr.setEquipmentid(equipmentid);

                    String timestamp = "";
                    if (dtime != null) {
                        timestamp = DateUtil.format(dtime, DatePattern.NORM_DATETIME_PATTERN);
                        attr.setTimestamp(timestamp);
                    }
                    attr.setPhase(phase);
                    attr.setKey(field);
                    attr.setValue(ival);
                    if (StrUtil.equals(tableName, Constant.data_byq_jbfd)) {
                        attr.setDevicetype(Constant.BYQ_JBFD);
                    } else if (StrUtil.equals(tableName, Constant.data_cnj)) {
                        attr.setDevicetype(Constant.CNJ);
                    } else if (StrUtil.equals(tableName, Constant.data_dcyw)) {
                        attr.setDevicetype(Constant.DCYW);
                    } else if (StrUtil.equals(tableName, Constant.data_dlq_jbfd)) {
                        attr.setDevicetype(Constant.DLQJBFD);
                    } else if (StrUtil.equals(tableName, Constant.data_dr_jyjc)) {
                        attr.setDevicetype(Constant.DRJYJC);
                    } else if (StrUtil.equals(tableName, Constant.data_fhdlbx)) {
                        attr.setDevicetype(Constant.FHDLBX);
                    } else if (StrUtil.equals(tableName, Constant.data_fhzxq)) {
                        attr.setDevicetype(Constant.FHZXQ);
                    } else if (StrUtil.equals(tableName, Constant.data_jsyhw_jyjc)) {
                        attr.setDevicetype(Constant.JSYHW);
                    } else if (StrUtil.equals(tableName, Constant.data_microclimate)) {
                        attr.setDevicetype(Constant.WQX);
                    } else if (StrUtil.equals(tableName, Constant.data_sf6_qtsf)) {
                        attr.setDevicetype(Constant.SF6_QTSF);
                    } else if (StrUtil.equals(tableName, Constant.data_sf6_qtyl)) {
                        attr.setDevicetype(Constant.SF6_QTYL);
                    } else if (StrUtil.equals(tableName, Constant.data_tx)) {
                        attr.setDevicetype(Constant.TX);
                    } else if (StrUtil.equals(tableName, Constant.data_ws)) {
                        attr.setDevicetype(Constant.WS);
                    } else if (StrUtil.equals(tableName, Constant.data_ysp)) {
                        attr.setDevicetype(Constant.YSP);
                    }
                    try {
                        String xml = GenerateI2Xml.generateYxCacXml(attr);
                        if (xml != null && !xml.equals("")) {
                            asyncMethod.sendData2(client, xml);
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                    }

                }
                asyncMethod.updateRecordId(maxid, Constant.YXID);
            } else {
//                iscontiue = false;
                log.info("没有查询到yx的数据");
            }
//        }
    }

    @Override
    public void clear_history() {
        log.info("开启定时删除");
        DateTime dateTime = DateUtil.offsetDay(new Date(), -3);
        data_byq_jbfdDao.deleteData(dateTime);
        data_cnjDao.deleteData(dateTime);
        data_dcywDao.deleteData(dateTime);
        data_dlq_jbfdDao.deleteData(dateTime);
        data_dr_jyjcDao.deleteData(dateTime);
        data_fhdlbxDao.deleteData(dateTime);
        data_fhzxqDao.deleteData(dateTime);
        data_jsyhw_jyjcDao.deleteData(dateTime);
        data_microclimateDao.deleteData(dateTime);
        data_sf6_qtsfDao.deleteData(dateTime);
        data_sf6_qtylDao.deleteData(dateTime);
        data_txDao.deleteData(dateTime);
        data_wsDao.deleteData(dateTime);
        data_yspDao.deleteData(dateTime);
        data_yxDao.deleteData(dateTime);
    }


}
