package com.shxy.i2.timeTask;

import com.shxy.i2.service.Webservcies;
import com.shxy.i2.service.XydlI2Service;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Async;
import org.springframework.scheduling.annotation.EnableAsync;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

/**
 * @author jingjing
 * @date 2023-11-16 15:06
 */
@Component
@EnableScheduling
@Slf4j
@EnableAsync
public class ScheduledTask {

    @Autowired
    Webservcies webservcies;

    @Autowired
    XydlI2Service xydlI2Service;


    @Scheduled(fixedDelay = 60 * 60 * 1000)
    public void cacyspupload() {
        log.info("cacyspupload执行"  );
        webservcies.uploadyspData();
    }

    @Scheduled(fixedDelay = 10 * 60 * 1000)
    public void cacjfjcupload() {
        log.info("cacjfjcupload执行" );
        webservcies.uploadjfjcData();
    }

    @Scheduled(fixedDelay = 1 * 30 * 1000)
    public void cacupload() {
        log.info("cacupload执行"  );
        webservcies.uploadData();
    }

    @Scheduled(fixedDelay = 1 * 30 * 1000)
    public void cacyxupload() {
        log.info("cacyxupload执行"  );
        webservcies.uploadyxData();
    }

    @Scheduled(fixedDelay = 1 * 30 * 1000)
    public void cacdcywupload() {
        log.info("cacdcywupload执行"  );
        webservcies.uploaddcywData();
    }

    @Scheduled(fixedDelay = 1 * 30 * 1000)
    public void cacjsyhwjyjcupload() {
        log.info("cacjsyhwjyjcupload执行" );
        webservcies.uploadjsyhwjyjcData();
    }


    @Scheduled(cron = "0 0 13 * * ?")
    public void clear() {
        log.info("clear" );
        xydlI2Service.clear_history();
    }

}
